// Clears the Blog
function sidarext_clearBlog()
{
    window.opener.sidarext_blogDescription = null;
    window.opener.sidarext_blogKey         = null;
    window.opener.sidarext_blogURL         = null;
}

// Initializes the Blog dialog box
function sidarext_initializeBlog()
{
    const stringBundle = document.getElementById("sidarext-string-bundle");

    // If the first argument equals add
    if(window.arguments[0] == "add")
    {
        title = stringBundle.getString("sidarext_addBlogTitle");
    }
    else
    {
        title = stringBundle.getString("sidarext_editBlogTitle");

        document.getElementById("sidarext.blog.description").value = window.arguments[1];
        document.getElementById("sidarext.blog.key").value         = window.arguments[3];
        document.getElementById("sidarext.blog.url").value         = window.arguments[2];
    }
}

// Saves the blog
function sidarext_saveBlog()
{
    const description  = document.getElementById("sidarext.blog.description").value.trim();
    const key          = document.getElementById("sidarext.blog.key").value.trim();
    const stringBundle = document.getElementById("sidarext-string-bundle");
    const url          = document.getElementById("sidarext.blog.url").value.trim();

    var errors = "";

    // If the description is empty
    if(!description)
    {
        errors += stringBundle.getString("sidarext_emptyDescription") + "\n";
    }

    // If the URL is empty
    if(!url)
    {
        errors += stringBundle.getString("sidarext_emptyURL") + "\n";
    }

    // If there are errors
    if(errors)
    {
        alert(errors.trim());
        return false;
    }
    else
    {
        window.opener.sidarext_blogDescription = description;
        window.opener.sidarext_blogKey         = key;
        window.opener.sidarext_blogURL         = url;

        return true;
    }
}
