// Clears the list
function sidarext_clearList()
{
    window.opener.sidarext_listDescription = null;
    window.opener.sidarext_listKey         = null;
    window.opener.sidarext_listURL         = null;
}

// Initializes the list dialog box
function sidarext_initializeList()
{
    const stringBundle = document.getElementById("sidarext-string-bundle");

    // If the first argument equals add
    if(window.arguments[0] == "add")
    {
        title = stringBundle.getString("sidarext_addListTitle");
    }
    else
    {
        title = stringBundle.getString("sidarext_editListTitle");

        document.getElementById("sidarext.list.description").value = window.arguments[1];
        document.getElementById("sidarext.list.key").value         = window.arguments[3];
        document.getElementById("sidarext.list.url").value         = window.arguments[2];
    }
}

// Saves the list
function sidarext_saveList()
{
    const description  = document.getElementById("sidarext.list.description").value.trim();
    const key          = document.getElementById("sidarext.list.key").value.trim();
    const stringBundle = document.getElementById("sidarext-string-bundle");
    const url          = document.getElementById("sidarext.list.url").value.trim();

    var errors = "";

    // If the description is empty
    if(!description)
    {
        errors += stringBundle.getString("sidarext_emptyDescription") + "\n";
    }

    // If the URL is empty
    if(!url)
    {
        errors += stringBundle.getString("sidarext_emptyURL") + "\n";
    }

    // If there are errors
    if(errors)
    {
        alert(errors.trim());
        return false;
    }
    else
    {
        window.opener.sidarext_listDescription = description;
        window.opener.sidarext_listKey         = key;
        window.opener.sidarext_listURL         = url;

        return true;
    }
}
