// Clears the tool
function sidarext_clearTool()
{
    window.opener.sidarext_toolDescription = null;
    window.opener.sidarext_toolKey         = null;
    window.opener.sidarext_toolURL         = null;
}

// Initializes the tool dialog box
function sidarext_initializeTool()
{
    const stringBundle = document.getElementById("sidarext-string-bundle");

    // If the first argument equals add
    if(window.arguments[0] == "add")
    {
        title = stringBundle.getString("sidarext_addToolTitle");
    }
    else
    {
        title = stringBundle.getString("sidarext_editToolTitle");

        document.getElementById("sidarext.tool.description").value = window.arguments[1];
        document.getElementById("sidarext.tool.key").value         = window.arguments[3];
        document.getElementById("sidarext.tool.url").value         = window.arguments[2];
    }
}

// Saves the tool
function sidarext_saveTool()
{
    const description  = document.getElementById("sidarext.tool.description").value.trim();
    const key          = document.getElementById("sidarext.tool.key").value.trim();
    const stringBundle = document.getElementById("sidarext-string-bundle");
    const url          = document.getElementById("sidarext.tool.url").value.trim();

    var errors = "";

    // If the description is empty
    if(!description)
    {
        errors += stringBundle.getString("sidarext_emptyDescription") + "\n";
    }

    // If the URL is empty
    if(!url)
    {
        errors += stringBundle.getString("sidarext_emptyURL") + "\n";
    }

    // If there are errors
    if(errors)
    {
        alert(errors.trim());
        return false;
    }
    else
    {
        window.opener.sidarext_toolDescription = description;
        window.opener.sidarext_toolKey         = key;
        window.opener.sidarext_toolURL         = url;

        return true;
    }
}
