function sidarext_loadURL(url)
{

  const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
  const oldTab       = getBrowser().selectedTab;
  var openedPage = null;
  var newURL = url;

  if (preferencesService.prefHasUserValue("sidarext.options.tab.window"))
  {
    var option = preferencesService.getIntPref("sidarext.options.tab.window");
    var newTab;

    switch (option)
    {
      case 1:
        window._content.document.location = newURL;
        window.content.focus();
        break;
      case 2:
        newTab = getBrowser().addTab(newURL);
        getBrowser().selectedTab = newTab;
        if (preferencesService.prefHasUserValue("sidarext.options.open.tab.background"))
        {
          getBrowser().selectedTab = oldTab;
        }
        break;
      case 3:
        window.open(newURL);
        break;
    }
  }
  else
  {
    newTab = getBrowser().addTab(newURL);
    getBrowser().selectedTab = newTab;
    if (preferencesService.prefHasUserValue("sidarext.options.open.tab.background")
    && preferencesService.getBoolPref("sidarext.options.open.tab.background"))
    {
      getBrowser().selectedTab = oldTab;
    }
  }

  return openedPage;

}


function sidarext_open_sidar_page( page )
{
  var newURL = "http://www.sidar.org/";
  switch (page) {
    case 'home':
      newURL += "index.php";
    break;
    case 'what':
      newURL += "que/index.php";
    break;
    case 'resources':
      newURL += "recur/index.php";
    break;
    case 'inaction':
      newURL += "acti/index.php";
    break;
    case 'faqs':
      newURL += "faq/index.php";
    break;

    case 'blogs':
      newURL = "http://www.bitacoras.sidar.org/index.php";
    break;
    case 'blogAccesoweb':
      newURL = "http://www.bitacoras.sidar.org/accesoweb/index.php";
    break;
    case 'blogG1':
      newURL = "http://www.bitacoras.sidar.org/g1/index.php";
    break;
    case 'blogG2':
      newURL = "http://www.bitacoras.sidar.org/g2/index.php";
    break;
    case 'blogG3':
      newURL = "http://www.bitacoras.sidar.org/g3/index.php";
    break;
    case 'blogG4':
      newURL = "http://www.bitacoras.sidar.org/g4/index.php";
    break;
    case 'blogEmmy':
      newURL = "http://www.bitacoras.sidar.org/emmanuelle/";
    break;
    case 'blogWSHoy':
      newURL = "http://www.wshoy.sidar.org/";
    break;
    case 'blogChaals':
      newURL = "http://my.opera.com/chaals/blog/";
    break;

    case 'listAccesoweb':
      newURL = "http://es.groups.yahoo.com/group/accesoweb/";
    break;
    case 'listG1':
      newURL = "http://es.groups.yahoo.com/group/G1SIDAR/";
    break;
    case 'listG2':
      newURL = "http://es.groups.yahoo.com/group/G2SIDAR/";
    break;
    case 'listG3':
      newURL = "http://es.groups.yahoo.com/group/G3SIDAR/";
    break;
    case 'listG4':
      newURL = "http://es.groups.yahoo.com/group/G4SIDAR/";
    break;

  }

  sidarext_loadURL(newURL);

}

function sidarext_tool_page( url )
{
  var aURL = escape(getBrowser().currentURI.spec);
  var newURL = unescape( url ) + aURL;

  sidarext_loadURL(newURL);
}

function sidarext_add_other_page( category )
{
  const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
  const string             = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
  var title = getBrowser().contentTitle;
  var aURL = getBrowser().currentURI.spec;
  var categoryCount = 1;

  if (preferencesService.prefHasUserValue("sidarext."+category+".count"))
  {
    categoryCount = preferencesService.getIntPref("sidarext."+category+".count") + 1;
  }
  string.data = title;
  preferencesService.setComplexValue("sidarext."+category+"."+categoryCount+".description", Components.interfaces.nsISupportsString, string);
  string.data = aURL;
  preferencesService.setComplexValue("sidarext."+category+"."+categoryCount+".url", Components.interfaces.nsISupportsString, string);
  preferencesService.setIntPref("sidarext."+category+".count", categoryCount);

}



function sidarext_sidar_search()
{

  var aText = escape(document.getElementById("sidarext_toolbar_sidar_search_textbox").value);
  var aURL  = 'http://www.sidar.org/buscador/?q=' + aText + '&acc=Buscar';

  sidarext_loadURL(aURL);

}


function registerSidarextListener()
{
  if ( gBrowser )
    gBrowser.addProgressListener(SidarextListener, Components.interfaces.nsIWebProgress.NOTIFY_STATE_DOCUMENT);
}

function unregisterSidarextListener()
{
  if ( gBrowser )
    gBrowser.removeProgressListener(SidarextListener);
}

var SidarextListener =
{
  QueryInterface: function(aIID)
  {
  if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
    aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
    aIID.equals(Components.interfaces.nsISupports))
    return this;
  throw Components.results.NS_NOINTERFACE;
  },
  onLocationChange:function(aProgress, aRequest, aURI)
  {
    if ( !aProgress.isLoadingDocument )
    {
      if ( document.getElementById("heraext-context-separator") )
      {
        document.getElementById("sidarext-context-separator").hidden = !document.getElementById("heraext-context-separator").hidden;
        document.getElementById("sidarext-context").hidden           = !document.getElementById("heraext-context").hidden;
      }
      if ( document.getElementById("heraext-context-separator") )
      {
        document.getElementById("sidarext-validate-page-HERA").hidden = !document.getElementById("heraext-validate-page-HERA").hidden;
      }
    };
  },
  onStateChange:function(aProgress, aRequest, aFlag, aStatus)
  {
      if ( document.getElementById("heraext-context-separator") )
      {
        document.getElementById("sidarext-context-separator").hidden = !document.getElementById("heraext-context-separator").hidden;
        document.getElementById("sidarext-context").hidden           = !document.getElementById("heraext-context").hidden;
      }
      if ( document.getElementById("heraext-context-separator") )
      {
        document.getElementById("sidarext-validate-page-HERA").hidden = !document.getElementById("heraext-validate-page-HERA").hidden;
      }
  },
  onProgressChange:function(a,b,c,d,e,f){},
  onStatusChange:function(a,b,c,d){},
  onSecurityChange:function(a,b,c){},
  onLinkIconAvailable:function(a,b){}
}


function sidarext_showValidateLinkHERA( e )
{
  const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
  if (preferencesService.prefHasUserValue("sidarext.options.general.context.hide")
  && preferencesService.getBoolPref("sidarext.options.general.context.hide"))
  {
    document.getElementById("sidarext-popup-validate-page-HERA").hidden = true;
    document.getElementById("sidarext-validate-link-HERA").hidden = true;
    document.getElementById("sidarext-validate-frame-HERA").hidden = true;
    document.getElementById("sidarext-validate-textlink-HERA").hidden = true;
  }
  else
  {
    document.getElementById("sidarext-popup-validate-page-HERA").hidden = false;
    document.getElementById("sidarext-validate-link-HERA").hidden = true;
    if ( gContextMenu.onLink ) {
      document.getElementById("sidarext-validate-link-HERA").hidden = false;
      aURL = gContextMenu.link.href;
    }
    document.getElementById("sidarext-validate-frame-HERA").hidden = true;
    if ( gContextMenu.inFrame ) {
      document.getElementById("sidarext-validate-frame-HERA").hidden = false;
      aURL = gContextMenu.link.href;
    }
    var isTextSelection = false;
    if (gContextMenu)
      isTextSelection = gContextMenu.isTextSelected;
    document.getElementById("sidarext-validate-textlink-HERA").hidden = !isTextSelection;
  }

  if (preferencesService.prefHasUserValue("sidarext.options.general.menu.hide")
  && preferencesService.getBoolPref("sidarext.options.general.menu.hide"))
  {
    document.getElementById("sidarext-validate-page-HERA").hidden = preferencesService.getBoolPref("sidarext.options.general.menu.hide");
  }
  if (preferencesService.prefHasUserValue("heraext.options.general.menu.hide")
  && preferencesService.getBoolPref("heraext.options.general.menu.hide"))
  {
    document.getElementById("sidarext-validate-page-HERA").hidden = !preferencesService.getBoolPref("heraext.options.general.menu.hide");
  }
  return;
}

function sidarext_validate_link_HERA()
{
  var aURL = escape(gContextMenu.link.href);
  sidarext_validate_hera(aURL);
}

function sidarext_validate_page_hera()
{
  var aURL = escape(getBrowser().currentURI.spec);
  sidarext_validate_hera(aURL);
}

function sidarext_validate_frame_HERA()
{
  var aURL = escape(gContextMenu.target.ownerDocument.location.href);
  sidarext_validate_hera(aURL);
}

function sidarext_validate_textlink_HERA()
{
  var aURL = escape(sidarext_fixURL(gContextMenu.searchSelected()));
  sidarext_validate_hera(aURL);
}

function sidarext_validate_hera( aURL )
{
  const preferencesService    = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
  const generalPreferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
  const oldTab          = getBrowser().selectedTab;
  const heraURL           = "http://www.sidar.org/hera/index.php" ;
  var locale = "es";

  // If the language preference is set
  if (preferencesService.prefHasUserValue("sidarext.options.general.language"))
  {
    locale = preferencesService.getCharPref("sidarext.options.general.language");
  }
  else
  {
    locale = generalPreferencesService.getCharPref("general.useragent.locale").substring(0, 2);
  }
  var   newURL = heraURL + "." + locale + "?url=" + aURL;

  sidarext_loadURL(newURL);

}



function sidarext_StoreOptions()
{
  const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

  preferencesService.setBoolPref("sidarext.options.general.context.hide", document.getElementById("sidarext.options.general.context.hide").checked);
  preferencesService.setBoolPref("sidarext.options.general.menu.hide", document.getElementById("sidarext.options.general.menu.hide").checked);
  preferencesService.setBoolPref("sidarext.options.general.statusbar.hide", document.getElementById("sidarext.options.general.statusbar.hide").checked);

  preferencesService.setCharPref("sidarext.options.general.language", document.getElementById("sidarext.options.general.language").value);

  preferencesService.setIntPref("sidarext.options.tab.window", document.getElementById("sidarext.options.tab.window").selectedIndex);
  preferencesService.setBoolPref("sidarext.options.open.tab.background", document.getElementById("sidarext.options.open.tab.background").checked);

}


function sidarext_initializeOptions()
{
  const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

  if (preferencesService.prefHasUserValue("sidarext.options.general.context.hide"))
  {
    document.getElementById("sidarext.options.general.context.hide").checked = preferencesService.getBoolPref("sidarext.options.general.context.hide");
  }
  else
  {
    document.getElementById("sidarext.options.general.context.hide").checked = false;
  }

  if (preferencesService.prefHasUserValue("sidarext.options.general.menu.hide"))
  {
    document.getElementById("sidarext.options.general.menu.hide").checked = preferencesService.getBoolPref("sidarext.options.general.menu.hide");
  }
  else
  {
    document.getElementById("sidarext.options.general.menu.hide").checked = false;
  }

  if (preferencesService.prefHasUserValue("sidarext.options.general.statusbar.hide"))
  {
    document.getElementById("sidarext.options.general.statusbar.hide").checked = preferencesService.getBoolPref("sidarext.options.general.statusbar.hide");
  }
  else
  {
    document.getElementById("sidarext.options.general.statusbar.hide").checked = false;
  }


  // If the language preference is set
  if (preferencesService.prefHasUserValue("sidarext.options.general.language"))
  {
    document.getElementById("sidarext.options.general.language").value = preferencesService.getCharPref("sidarext.options.general.language");
  }
  else
  {
    document.getElementById("sidarext.options.general.language").value = preferencesService.getCharPref("general.useragent.locale").substring(0, 2);
  }

  if (preferencesService.prefHasUserValue("sidarext.options.tab.window"))
  {
    document.getElementById("sidarext.options.tab.window").selectedIndex = preferencesService.getIntPref("sidarext.options.tab.window") - 1;
  }
  else
  {
    document.getElementById("sidarext.options.tab.window").selectedIndex = 1;
  }

  if (preferencesService.prefHasUserValue("sidarext.options.open.tab.background"))
  {
    document.getElementById("sidarext.options.open.tab.background").checked = preferencesService.getBoolPref("sidarext.options.open.tab.background");
  }
  else
  {
    document.getElementById("sidarext.options.open.tab.background").checked = false;
  }

  sidarext_updateTabOptionStatus();

}



function sidarext_updateTabOptionStatus()
{

  if (document.getElementById("sidarext.options.tab.window").selectedIndex == 1)
  {
    document.getElementById("sidarext.options.open.tab.background").disabled = false;
  }
  else
  {
    document.getElementById("sidarext.options.open.tab.background").disabled = true;
  }

}


function sidarext_fixURL (url)
{
  // strip bad leading and trailing characters
  // strip all whitespace
  url = url.replace(/[\n\t ]+/, "");
  // strip bad leading characters
  url = url.replace(/^[^a-zA-Z]+/, "");
  // strip bad ending characters
  url = url.replace(/[\.,\'\"\)\?!>\]]+$/, "");

  // make sure it has some sort of protocol
  if(url.search(/^\w+:\/\//) == -1)
    url = "http://" + url;

  // these get used a lot.  guess this makes it more useful.
  // h*p -> http
  // f*p -> ftp
  if(url.search(/^h.+p:\/\//) != -1)
    url = url.replace(/^h.+p:\/\//, "http://");
  if(url.search(/^f.+p:\/\//) != -1)
    url = url.replace(/^f.+p:\/\//, "ftp://");

  return url;
}

function sidarext_initOverlay( e )
{
  if ( !document )
    return;

  var menu = document.getElementById("contentAreaContextMenu");
  menu.addEventListener("popupshowing", sidarext_showValidateLinkHERA, false);

  const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

  if (preferencesService.prefHasUserValue("sidarext.options.general.context.hide")
  && preferencesService.getBoolPref("sidarext.options.general.context.hide"))
  {
    document.getElementById("sidarext-context-separator").hidden    = preferencesService.getBoolPref("sidarext.options.general.context.hide");
    document.getElementById("sidarext-context").hidden          = preferencesService.getBoolPref("sidarext.options.general.context.hide");
  }
  if (preferencesService.prefHasUserValue("heraext.options.general.context.hide")
  && preferencesService.getBoolPref("heraext.options.general.context.hide"))
  {
    document.getElementById("sidarext-context-separator").hidden = !preferencesService.getBoolPref("heraext.options.general.context.hide");
    document.getElementById("sidarext-context").hidden           = !preferencesService.getBoolPref("heraext.options.general.context.hide");
  }

  if (preferencesService.prefHasUserValue("sidarext.options.general.menu.hide")
  && preferencesService.getBoolPref("sidarext.options.general.menu.hide"))
  {
    document.getElementById("sidarext-validate-page-HERA").hidden = preferencesService.getBoolPref("sidarext.options.general.menu.hide");
  }
  if (preferencesService.prefHasUserValue("heraext.options.general.menu.hide")
  && preferencesService.getBoolPref("heraext.options.general.menu.hide"))
  {
    document.getElementById("sidarext-validate-page-HERA").hidden = !preferencesService.getBoolPref("heraext.options.general.menu.hide");
  }

  if (preferencesService.prefHasUserValue("sidarext.options.general.statusbar.hide")
  && preferencesService.getBoolPref("sidarext.options.general.statusbar.hide"))
  {
    document.getElementById("sidarext-statusbar-panel").hidden = preferencesService.getBoolPref("sidarext.options.general.statusbar.hide");
  }

  return;
}

window.addEventListener("load", sidarext_initOverlay, false);
window.addEventListener("load", registerSidarextListener, false);
window.addEventListener("unload", unregisterSidarextListener, false);
